﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Persistence.Services;
using Telerik.Windows.Controls;
using Telerik.Windows.Persistence.Storage;

namespace GridViewSerialization
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			// register the custom property provider for the RadGridView:
			ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView), new GridViewCustomPropertyProvider());
            ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadDocking), new DockingCustomPropertyProvider());

			this.DataContext = ExamplesDB.GetCustomers();

			Application.Current.Exit += (s, e) =>
			{
				IsolatedStorageProvider provider = new IsolatedStorageProvider();
				provider.SaveToStorage();
			};

            this.Loaded += new RoutedEventHandler(MainPage_Loaded);

		}

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            IsolatedStorageProvider provider = new IsolatedStorageProvider();
            provider.LoadFromStorage("DockingControl"); 
        }

        bool isGridLoaded;
        private void RadGridView_Loaded(object sender, RoutedEventArgs e)
        {
            if (!isGridLoaded)
            {
                Dispatcher.BeginInvoke(new Action(() =>
                {
                    IsolatedStorageProvider provider = new IsolatedStorageProvider();
                    provider.LoadFromStorage("GridView1");
                    isGridLoaded = true;
                }));
            }
        }
	}
}
